inlets = 1;
outlets = 2;
var TEMP_CONNECTION_OUTLET = 1;

var THIS = this; // jsthis object

var JM_PREFIX = "jm#";
var VP_PREFIX = "vp#";

var NUMBER_JMS = 25;
var NUMBER_VPS = 25;

var usedMovieIndices = []; // this is a "set"
var tileArray = [];

var switched = false;

function contains(array, thing) {
    for (var i = 0; i < array.length; i++) {
        if (array[i] === thing) {
            return true;
        }
    }
    return false;
}

function setAdd(setToAddTo, thingToAdd) {
    if (!contains(setToAddTo, thingToAdd)) {
        setToAddTo.push(thingToAdd);
        return setToAddTo;
    }
    return setToAddTo;
}

function switchLayout() {

    var layoutFlatArray;
    if (switched) {
        layoutFlatArray = [1, 0.25, 0.25, 0.75, -0.75, 2, 0.25, 0.25, 0.25, -0.75, 3, 0.25, 0.25, -0.25, -0.75, 4, 0.25, 0.25, -0.75, -0.75, 1, 0.25, 0.25, 0.75, -0.25, 2, 0.25, 0.25, 0.25, -0.25, 3, 0.25, 0.25, -0.25, -0.25, 4, 0.25, 0.25, -0.75, -0.25, 1, 0.25, 0.25, 0.75, 0.25, 2, 0.25, 0.25, 0.25, 0.25, 3, 0.25, 0.25, -0.25, 0.25, 4, 0.25, 0.25, -0.75, 0.25, 1, 0.25, 0.25, 0.75, 0.75, 2, 0.25, 0.25, 0.25, 0.75, 3, 0.25, 0.25, -0.25, 0.75, 4, 0.25, 0.25, -0.75, 0.75];
    } else {
        layoutFlatArray = [3, 0.25, 0.25, 0.75, -0.75, 1, 0.25, 0.25, 0.25, -0.75, 3, 0.25, 0.25, -0.25, -0.75, 1, 0.25, 0.25, -0.75, -0.75, 1, 0.25, 0.25, 0.75, -0.25, 3, 0.25, 0.25, 0.25, -0.25, 1, 0.25, 0.25, -0.25, -0.25, 3, 0.25, 0.25, -0.75, -0.25, 3, 0.25, 0.25, 0.75, 0.25, 1, 0.25, 0.25, 0.25, 0.25, 3, 0.25, 0.25, -0.25, 0.25, 1, 0.25, 0.25, -0.75, 0.25, 1, 0.25, 0.25, 0.75, 0.75, 3, 0.25, 0.25, 0.25, 0.75, 1, 0.25, 0.25, -0.25, 0.75, 3, 0.25, 0.25, -0.75, 0.75];
    }
    switched = !switched;

    tileArray = [];
    // chunk (unflatten) the array
    usedMovieIndices = []; // this is a "set"
    while (layoutFlatArray.length > 0) {
        if (layoutFlatArray.length < 5)
            break;
        var movieTile = {
            movieIndex: Number(layoutFlatArray.shift()),
            scaleX: Number(layoutFlatArray.shift()),
            scaleY: Number(layoutFlatArray.shift()),
            posX: Number(layoutFlatArray.shift()),
            posY: Number(layoutFlatArray.shift())
        }

        setAdd(usedMovieIndices, movieTile.movieIndex);
        tileArray.push(movieTile);
    }

    // takes care of VP objects and connects them to their JMs
    THIS.patcher.applyif(populateVP, isVP);

    // takes care of JM objects
    THIS.patcher.applyif(startOrStopJM, isJM);
}

function populateVP(vp) {

    // get VP scripting name
    var scriptingName = vp.varname;
    var scriptingNameParts = scriptingName.split("#");

    // get the index from the scripting name
    var vpIndex = scriptingNameParts[1];

    // disconnect all incoming patch cords from the VP
    var patchcords = vp.patchcords;
    if (patchcords) {
        var inputs = patchcords.inputs;
        for (var i = 0; i < inputs.length; i++) {
            var input = inputs[i];
            THIS.patcher.disconnect(input.srcobject, input.srcoutlet, input.dstobject, input.dstinlet);
        }
    }

    // send scale and position data into the VP and or enable / disable it
    if (vpIndex < tileArray.length) {
        var tile = tileArray[vpIndex];

        // get the associated JM
        var jm = THIS.patcher.getnamed(JM_PREFIX + (tile.movieIndex - 1));
        // connect the VP to its associated JM
        THIS.patcher.connect(jm, 0, vp, 0);

        // sending VP the scaling and position data
        THIS.patcher.connect(THIS.box, TEMP_CONNECTION_OUTLET, vp, 1);
        outlet(TEMP_CONNECTION_OUTLET, tile.scaleX, tile.scaleY, tile.posX, tile.posY);
        THIS.patcher.disconnect(THIS.box, TEMP_CONNECTION_OUTLET, vp, 1);

        // enable the VP
        THIS.patcher.connect(THIS.box, TEMP_CONNECTION_OUTLET, vp, 2);
        outlet(TEMP_CONNECTION_OUTLET, 1);
        THIS.patcher.disconnect(THIS.box, TEMP_CONNECTION_OUTLET, vp, 2);
    } else {
        // disables unused VPs
        THIS.patcher.connect(THIS.box, TEMP_CONNECTION_OUTLET, vp, 2);
        outlet(TEMP_CONNECTION_OUTLET, 0);
        THIS.patcher.disconnect(THIS.box, TEMP_CONNECTION_OUTLET, vp, 2);
    }

}

function isVP(possibleVP) {

    var scriptingName = possibleVP.varname;
    if (!scriptingName) return false;

    // full scripting name shoudl look like this: vp#99
    var scriptingNameParts = scriptingName.split("#"); // [vp, 99]

    if (!scriptingNameParts.length == 2) return false;
    if (scriptingNameParts[0] !== "vp") return false;

    return true;

}

function isJM(possibleJM) {

    var scriptingName = possibleJM.varname;
    if (!scriptingName) return false;

    // full scripting name shoudl look like this: jm#99
    var scriptingNameParts = scriptingName.split("#"); // [jm, 99]

    if (!scriptingNameParts.length == 2) return false;
    if (scriptingNameParts[0] !== "jm") return false;

    return true;
}

function startOrStopJM(jm) {

    // get the scripting name of the JM
    var scriptingName = jm.varname;
    var scriptingNameParts = scriptingName.split("#");

    // get the index of the JM Max object (0 based --> 1 based)
    var jmIndex = Number(scriptingNameParts[1]) + 1;

    // populate JM and start it / stop it if it isn't being used
    if (contains(usedMovieIndices, jmIndex)) {

        // tell the JM to load its movie file
        THIS.patcher.connect(THIS.box, TEMP_CONNECTION_OUTLET, jm, 0);
        outlet(TEMP_CONNECTION_OUTLET, jmIndex);
        THIS.patcher.disconnect(THIS.box, TEMP_CONNECTION_OUTLET, jm, 0);

        // start the playback
        THIS.patcher.connect(THIS.box, TEMP_CONNECTION_OUTLET, jm, 1);
        outlet(TEMP_CONNECTION_OUTLET, "start");
        THIS.patcher.disconnect(THIS.box, TEMP_CONNECTION_OUTLET, jm, 1);

    } else {

        // stop unused JMs
        THIS.patcher.connect(THIS.box, TEMP_CONNECTION_OUTLET, jm, 1);
        outlet(TEMP_CONNECTION_OUTLET, "stop");
        THIS.patcher.disconnect(THIS.box, TEMP_CONNECTION_OUTLET, jm, 1);

    }

}
